=== debian/changelog ===
freerdp3 (3.22.0+dfsg-3) unstable; urgency=medium

  * d/control: add libwinpr3-3:Replaces: libwinpr2-2 to override wlog.7.
    There's no upgrade path from freerdp2 in bookworm to freerdp3 in trixie,
    so if the user had freerdp2 installed in bookworm and upgraded the system
    to trixie, it is very likely they still have freerdp2 installed (obsolete
    package).  And the new libwinp3-3 ships the same manpage as the old
    libwinpr2-2.  Allow replacing this file when installing new libwinpr3-3.
    Do not add Breaks: though, since this way, all freerdp2 packages has to
    be removed (which might be a good thing in the end, but for that we ought
    to provide xfreerdp2 etc binaries too).  Also Breaks libwinpr2-2t64, since
    apparently some users managed to install the t64 packages on a bookworm
    system somehow.  (Closes: #1127622)
  * rename source package back to freerdp3.  It turned out this is too much
    pain (security tracker, bug reports, autopkgtests, etc) for nothing.
    Suggest renaming it to freerdp at freerdp4 time.

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 11 Feb 2026 12:08:45 +0300

freerdp (3.22.0+dfsg-2) unstable; urgency=medium

  * package rename.  We had freerdp, freerdp2, freerdp3, - due to big rewrite
    upstream from 1.x to 2.x which was going in parallel with 1.x, and it was
    unclear when 2.x will be ready.  Next, during 2.x to 3.x, it was a steady
    update, which stayed compatible with 2.x series.  But the project itself
    is named "freerdp" without any version suffix.  And we had no upgrade path
    from bookworm (which has freerdp2 only) to trixie (freerdp3 only).  There's
    no actual reason to carry the suffix, at least not anymore.  Let's name it
    "freerdp" without any suffix, and provide compatibility end-user packages
    with compatibility naming.  Rename source package from freerdp3 to freerdp
  * rename end-user binary packages: freerdp3-x11, freerdp3-sdl,
    freerdp3-wayland, freerdp3-proxy, freerdp3-proxy-modules, winpr3-utils
    to drop the "3" version suffix from both the name of the package and
    the name of the binary.  Provide transitional packages with old names,
    containing symlinks to new binaries
  * update CVE references in the previous changelog entry

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 10 Feb 2026 12:24:09 +0300

freerdp3 (3.22.0+dfsg-1) unstable; urgency=medium

  * new upstream major bugfix release, with overhaul of SDL3 client and
    multiple security fixes for the following client-side vulnerabilities:
    CVE-2026-23948 NULL Pointer Dereference in rdp_write_logon_info_v2()
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-6f3c-qvqq-2px5
    CVE-2026-24491 Heap-use-after-free in video_timer
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-4x6j-w49r-869g
    CVE-2026-24675 Heap-use-after-free in urb_select_interface
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-x9jr-99h2-g7mj
    CVE-2026-24676 Heap-use-after-free in audio_format_compatible
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-qh5p-frq4-pgxj
    CVE-2026-24677 Heap-buffer-overflow in ecam_encoder_compress_h264
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-xw37-j744-f8v7
    CVE-2026-24678 Heap-use-after-free in cam_v4l_stream_capture_thread
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-6gvg-29wx-6v7h
    CVE-2026-24679 Heap-buffer-overflow in urb_select_interface
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-2jp4-67x6-gv7x
    CVE-2026-24680 Heap-use-after-free in update_pointer_new(SDL)
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-j893-9wg8-33rc
    CVE-2026-24681 Heap-use-after-free in urb_bulk_transfer_cb
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-ccvv-hg2w-6x9j
    CVE-2026-24682 Heap-buffer-overflow in audio_formats_free
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-vcw2-pqgw-mx6g
    CVE-2026-24683 Heap-use-after-free in ainput_send_input_event
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-45pf-68pj-fg8q
    CVE-2026-24684 Heap-use-after-free in play_thread
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-vcgv-xgjp-h83q
  * update libfreerdp symbols file (add new symbols)

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 29 Jan 2026 11:22:26 +0300
